<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for LibGraphes.py: 47%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">
<div id="header">
    <div class="content">
        <h1>Coverage for <b>LibGraphes.py</b> :
            <span class="pc_cov">47%</span>
        </h1>
        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />
        <h2 class="stats">
            133 statements &nbsp;
            <span class="run shortkey_r button_toggle_run">62 run</span>
            <span class="mis show_mis shortkey_m button_toggle_mis">71 missing</span>
            <span class="exc show_exc shortkey_x button_toggle_exc">0 excluded</span>
        </h2>
    </div>
</div>
<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>
<div id="source">
    <p id="t1" class="pln"><span class="n"><a href="#t1">1</a></span><span class="t"><span class="str">""" A Python Class for Non Oriented Graphs</span>&nbsp;</span><span class="r"></span></p>
    <p id="t2" class="pln"><span class="n"><a href="#t2">2</a></span><span class="t"><span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t3" class="pln"><span class="n"><a href="#t3">3</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t4" class="run"><span class="n"><a href="#t4">4</a></span><span class="t"><span class="key">from</span> <span class="nam">copy</span> <span class="key">import</span> <span class="nam">deepcopy</span>&nbsp;</span><span class="r"></span></p>
    <p id="t5" class="pln"><span class="n"><a href="#t5">5</a></span><span class="t"><span class="com"># for dot output</span>&nbsp;</span><span class="r"></span></p>
    <p id="t6" class="run"><span class="n"><a href="#t6">6</a></span><span class="t"><span class="key">from</span> <span class="nam">graphviz</span> <span class="key">import</span> <span class="nam">Digraph</span>&nbsp;</span><span class="r"></span></p>
    <p id="t7" class="pln"><span class="n"><a href="#t7">7</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t8" class="pln"><span class="n"><a href="#t8">8</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t9" class="run"><span class="n"><a href="#t9">9</a></span><span class="t"><span class="key">class</span> <span class="nam">Error</span><span class="op">(</span><span class="nam">Exception</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t10" class="pln"><span class="n"><a href="#t10">10</a></span><span class="t">    <span class="str">"""Base class for exceptions in this module."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t11" class="run"><span class="n"><a href="#t11">11</a></span><span class="t">    <span class="key">pass</span>&nbsp;</span><span class="r"></span></p>
    <p id="t12" class="pln"><span class="n"><a href="#t12">12</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t13" class="pln"><span class="n"><a href="#t13">13</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t14" class="run"><span class="n"><a href="#t14">14</a></span><span class="t"><span class="key">class</span> <span class="nam">GraphError</span><span class="op">(</span><span class="nam">Error</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t15" class="pln"><span class="n"><a href="#t15">15</a></span><span class="t">    <span class="str">"""Exception raised for self loops</span>&nbsp;</span><span class="r"></span></p>
    <p id="t16" class="pln"><span class="n"><a href="#t16">16</a></span><span class="t"><span class="str">    """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t17" class="pln"><span class="n"><a href="#t17">17</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t18" class="run"><span class="n"><a href="#t18">18</a></span><span class="t">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">message</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t19" class="mis show_mis"><span class="n"><a href="#t19">19</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">message</span> <span class="op">=</span> <span class="nam">message</span>&nbsp;</span><span class="r"></span></p>
    <p id="t20" class="pln"><span class="n"><a href="#t20">20</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t21" class="pln"><span class="n"><a href="#t21">21</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t22" class="run"><span class="n"><a href="#t22">22</a></span><span class="t"><span class="key">class</span> <span class="nam">Graph</span><span class="op">(</span><span class="nam">object</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t23" class="pln"><span class="n"><a href="#t23">23</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t24" class="run"><span class="n"><a href="#t24">24</a></span><span class="t">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">graph_dict</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t25" class="pln"><span class="n"><a href="#t25">25</a></span><span class="t">        <span class="str">""" initializes a graph object</span>&nbsp;</span><span class="r"></span></p>
    <p id="t26" class="pln"><span class="n"><a href="#t26">26</a></span><span class="t"><span class="str">            If no dictionary or None is given,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t27" class="pln"><span class="n"><a href="#t27">27</a></span><span class="t"><span class="str">            an empty dictionary will be used</span>&nbsp;</span><span class="r"></span></p>
    <p id="t28" class="pln"><span class="n"><a href="#t28">28</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t29" class="run"><span class="n"><a href="#t29">29</a></span><span class="t">        <span class="key">if</span> <span class="nam">graph_dict</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t30" class="run"><span class="n"><a href="#t30">30</a></span><span class="t">            <span class="nam">graph_dict</span> <span class="op">=</span> <span class="op">{</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t31" class="run"><span class="n"><a href="#t31">31</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span> <span class="op">=</span> <span class="nam">graph_dict</span>&nbsp;</span><span class="r"></span></p>
    <p id="t32" class="pln"><span class="n"><a href="#t32">32</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t33" class="run"><span class="n"><a href="#t33">33</a></span><span class="t">    <span class="key">def</span> <span class="nam">vertices</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t34" class="pln"><span class="n"><a href="#t34">34</a></span><span class="t">        <span class="str">""" returns the vertices of a graph """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t35" class="mis show_mis"><span class="n"><a href="#t35">35</a></span><span class="t">        <span class="key">return</span> <span class="nam">list</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">.</span><span class="nam">keys</span><span class="op">(</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t36" class="pln"><span class="n"><a href="#t36">36</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t37" class="run"><span class="n"><a href="#t37">37</a></span><span class="t">    <span class="key">def</span> <span class="nam">edges</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t38" class="pln"><span class="n"><a href="#t38">38</a></span><span class="t">        <span class="str">""" returns the edges of a graph """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t39" class="mis show_mis"><span class="n"><a href="#t39">39</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__generate_edges</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t40" class="pln"><span class="n"><a href="#t40">40</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t41" class="run"><span class="n"><a href="#t41">41</a></span><span class="t">    <span class="key">def</span> <span class="nam">add_vertex</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">vertex</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t42" class="pln"><span class="n"><a href="#t42">42</a></span><span class="t">        <span class="str">""" If the vertex "vertex" is not in</span>&nbsp;</span><span class="r"></span></p>
    <p id="t43" class="pln"><span class="n"><a href="#t43">43</a></span><span class="t"><span class="str">            self.__graph_dict, a key "vertex" with an empty</span>&nbsp;</span><span class="r"></span></p>
    <p id="t44" class="pln"><span class="n"><a href="#t44">44</a></span><span class="t"><span class="str">            list as a value is added to the dictionary.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t45" class="pln"><span class="n"><a href="#t45">45</a></span><span class="t"><span class="str">            Otherwise nothing has to be done.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t46" class="pln"><span class="n"><a href="#t46">46</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t47" class="run"><span class="n"><a href="#t47">47</a></span><span class="t">        <span class="key">if</span> <span class="nam">vertex</span> <span class="key">not</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t48" class="run"><span class="n"><a href="#t48">48</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">[</span><span class="nam">vertex</span><span class="op">]</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t49" class="pln"><span class="n"><a href="#t49">49</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t50" class="run"><span class="n"><a href="#t50">50</a></span><span class="t">    <span class="key">def</span> <span class="nam">add_edge</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">edge</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t51" class="pln"><span class="n"><a href="#t51">51</a></span><span class="t">        <span class="str">""" edge should be a pair and not (c,c)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t52" class="pln"><span class="n"><a href="#t52">52</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t53" class="run"><span class="n"><a href="#t53">53</a></span><span class="t">        <span class="key">try</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t54" class="run"><span class="n"><a href="#t54">54</a></span><span class="t">            <span class="op">(</span><span class="nam">vertex1</span><span class="op">,</span> <span class="nam">vertex2</span><span class="op">)</span> <span class="op">=</span> <span class="nam">edge</span>&nbsp;</span><span class="r"></span></p>
    <p id="t55" class="run"><span class="n"><a href="#t55">55</a></span><span class="t">            <span class="key">if</span> <span class="nam">vertex1</span> <span class="op">==</span> <span class="nam">vertex2</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t56" class="mis show_mis"><span class="n"><a href="#t56">56</a></span><span class="t">                <span class="key">raise</span> <span class="nam">GraphError</span><span class="op">(</span><span class="str">"no self loop"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t57" class="run"><span class="n"><a href="#t57">57</a></span><span class="t">            <span class="key">if</span> <span class="nam">vertex1</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t58" class="run"><span class="n"><a href="#t58">58</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">[</span><span class="nam">vertex1</span><span class="op">]</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">vertex2</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t59" class="pln"><span class="n"><a href="#t59">59</a></span><span class="t">            <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t60" class="mis show_mis"><span class="n"><a href="#t60">60</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">[</span><span class="nam">vertex1</span><span class="op">]</span> <span class="op">=</span> <span class="op">[</span><span class="nam">vertex2</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t61" class="run"><span class="n"><a href="#t61">61</a></span><span class="t">            <span class="key">if</span> <span class="nam">vertex2</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t62" class="run"><span class="n"><a href="#t62">62</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">[</span><span class="nam">vertex2</span><span class="op">]</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">vertex1</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t63" class="pln"><span class="n"><a href="#t63">63</a></span><span class="t">            <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t64" class="mis show_mis"><span class="n"><a href="#t64">64</a></span><span class="t">                <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">[</span><span class="nam">vertex2</span><span class="op">]</span> <span class="op">=</span> <span class="op">[</span><span class="nam">vertex1</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t65" class="mis show_mis"><span class="n"><a href="#t65">65</a></span><span class="t">        <span class="key">except</span> <span class="nam">GraphError</span> <span class="key">as</span> <span class="nam">s</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t66" class="mis show_mis"><span class="n"><a href="#t66">66</a></span><span class="t">            <span class="nam">print</span><span class="op">(</span><span class="str">"pb with adding edge: "</span> <span class="op">+</span> <span class="nam">s</span><span class="op">.</span><span class="nam">message</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t67" class="mis show_mis"><span class="n"><a href="#t67">67</a></span><span class="t">            <span class="key">pass</span>&nbsp;</span><span class="r"></span></p>
    <p id="t68" class="pln"><span class="n"><a href="#t68">68</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t69" class="run"><span class="n"><a href="#t69">69</a></span><span class="t">    <span class="key">def</span> <span class="nam">__generate_edges</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t70" class="pln"><span class="n"><a href="#t70">70</a></span><span class="t">        <span class="str">""" A static method generating the set of edges</span>&nbsp;</span><span class="r"></span></p>
    <p id="t71" class="pln"><span class="n"><a href="#t71">71</a></span><span class="t"><span class="str">        (they appear twice in the dictionnary). Returns a list of sets.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t72" class="pln"><span class="n"><a href="#t72">72</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t73" class="mis show_mis"><span class="n"><a href="#t73">73</a></span><span class="t">        <span class="nam">edges</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t74" class="mis show_mis"><span class="n"><a href="#t74">74</a></span><span class="t">        <span class="key">for</span> <span class="nam">vertex</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t75" class="mis show_mis"><span class="n"><a href="#t75">75</a></span><span class="t">            <span class="key">for</span> <span class="nam">neighbour</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">[</span><span class="nam">vertex</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t76" class="mis show_mis"><span class="n"><a href="#t76">76</a></span><span class="t">                <span class="key">if</span> <span class="op">{</span><span class="nam">neighbour</span><span class="op">,</span> <span class="nam">vertex</span><span class="op">}</span> <span class="key">not</span> <span class="key">in</span> <span class="nam">edges</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t77" class="mis show_mis"><span class="n"><a href="#t77">77</a></span><span class="t">                    <span class="nam">edges</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="op">{</span><span class="nam">vertex</span><span class="op">,</span> <span class="nam">neighbour</span><span class="op">}</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t78" class="mis show_mis"><span class="n"><a href="#t78">78</a></span><span class="t">        <span class="key">return</span> <span class="nam">edges</span>&nbsp;</span><span class="r"></span></p>
    <p id="t79" class="pln"><span class="n"><a href="#t79">79</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t80" class="run"><span class="n"><a href="#t80">80</a></span><span class="t">    <span class="key">def</span> <span class="nam">__str__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t81" class="mis show_mis"><span class="n"><a href="#t81">81</a></span><span class="t">        <span class="nam">res</span> <span class="op">=</span> <span class="str">"vertices: "</span>&nbsp;</span><span class="r"></span></p>
    <p id="t82" class="mis show_mis"><span class="n"><a href="#t82">82</a></span><span class="t">        <span class="key">for</span> <span class="nam">k</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t83" class="mis show_mis"><span class="n"><a href="#t83">83</a></span><span class="t">            <span class="nam">res</span> <span class="op">+=</span> <span class="nam">str</span><span class="op">(</span><span class="nam">k</span><span class="op">)</span> <span class="op">+</span> <span class="str">" "</span>&nbsp;</span><span class="r"></span></p>
    <p id="t84" class="mis show_mis"><span class="n"><a href="#t84">84</a></span><span class="t">        <span class="nam">res</span> <span class="op">+=</span> <span class="str">"\nedges: "</span>&nbsp;</span><span class="r"></span></p>
    <p id="t85" class="mis show_mis"><span class="n"><a href="#t85">85</a></span><span class="t">        <span class="key">for</span> <span class="nam">edge</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__generate_edges</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t86" class="mis show_mis"><span class="n"><a href="#t86">86</a></span><span class="t">            <span class="nam">res</span> <span class="op">+=</span> <span class="nam">str</span><span class="op">(</span><span class="nam">edge</span><span class="op">)</span> <span class="op">+</span> <span class="str">" "</span>&nbsp;</span><span class="r"></span></p>
    <p id="t87" class="mis show_mis"><span class="n"><a href="#t87">87</a></span><span class="t">        <span class="key">return</span> <span class="nam">res</span>&nbsp;</span><span class="r"></span></p>
    <p id="t88" class="pln"><span class="n"><a href="#t88">88</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t89" class="run"><span class="n"><a href="#t89">89</a></span><span class="t">    <span class="key">def</span> <span class="nam">print_dot</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">name</span><span class="op">=</span><span class="str">"toto"</span><span class="op">,</span> <span class="nam">colors</span><span class="op">=</span><span class="op">{</span><span class="op">}</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t90" class="mis show_mis"><span class="n"><a href="#t90">90</a></span><span class="t">        <span class="nam">foo</span> <span class="op">=</span> <span class="op">[</span><span class="str">'red'</span><span class="op">,</span> <span class="str">'blue'</span><span class="op">,</span> <span class="str">'green'</span><span class="op">,</span> <span class="str">'yellow'</span><span class="op">]</span> <span class="op">+</span> <span class="op">(</span><span class="op">[</span><span class="str">'black'</span><span class="op">]</span> <span class="op">*</span> <span class="num">10</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t91" class="mis show_mis"><span class="n"><a href="#t91">91</a></span><span class="t">        <span class="nam">dot</span> <span class="op">=</span> <span class="nam">Digraph</span><span class="op">(</span><span class="nam">comment</span><span class="op">=</span><span class="str">'Conflict Graph'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t92" class="mis show_mis"><span class="n"><a href="#t92">92</a></span><span class="t">        <span class="key">for</span> <span class="nam">k</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t93" class="mis show_mis"><span class="n"><a href="#t93">93</a></span><span class="t">            <span class="key">if</span> <span class="key">not</span> <span class="nam">colors</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t94" class="mis show_mis"><span class="n"><a href="#t94">94</a></span><span class="t">                <span class="nam">color</span> <span class="op">=</span> <span class="str">"red"</span>  <span class="com"># Graph not colored: red for everyone</span>&nbsp;</span><span class="r"></span></p>
    <p id="t95" class="mis show_mis"><span class="n"><a href="#t95">95</a></span><span class="t">            <span class="key">elif</span> <span class="nam">k</span> <span class="key">not</span> <span class="key">in</span> <span class="nam">colors</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t96" class="mis show_mis"><span class="n"><a href="#t96">96</a></span><span class="t">                <span class="nam">color</span> <span class="op">=</span> <span class="str">"grey"</span>  <span class="com"># Node not colored: grey</span>&nbsp;</span><span class="r"></span></p>
    <p id="t97" class="pln"><span class="n"><a href="#t97">97</a></span><span class="t">            <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t98" class="mis show_mis"><span class="n"><a href="#t98">98</a></span><span class="t">                <span class="nam">color</span> <span class="op">=</span> <span class="nam">foo</span><span class="op">[</span><span class="nam">colors</span><span class="op">[</span><span class="nam">k</span><span class="op">]</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t99" class="mis show_mis"><span class="n"><a href="#t99">99</a></span><span class="t">            <span class="nam">dot</span><span class="op">.</span><span class="nam">node</span><span class="op">(</span><span class="nam">k</span><span class="op">,</span> <span class="nam">k</span><span class="op">,</span> <span class="nam">color</span><span class="op">=</span><span class="nam">color</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t100" class="mis show_mis"><span class="n"><a href="#t100">100</a></span><span class="t">        <span class="key">for</span> <span class="nam">edge</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__generate_edges</span><span class="op">(</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t101" class="pln"><span class="n"><a href="#t101">101</a></span><span class="t">            <span class="com"># print edge</span>&nbsp;</span><span class="r"></span></p>
    <p id="t102" class="mis show_mis"><span class="n"><a href="#t102">102</a></span><span class="t">            <span class="op">(</span><span class="nam">v1</span><span class="op">,</span> <span class="nam">v2</span><span class="op">)</span> <span class="op">=</span> <span class="nam">list</span><span class="op">(</span><span class="nam">edge</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">,</span> <span class="nam">list</span><span class="op">(</span><span class="nam">edge</span><span class="op">)</span><span class="op">[</span><span class="num">1</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t103" class="mis show_mis"><span class="n"><a href="#t103">103</a></span><span class="t">            <span class="nam">dot</span><span class="op">.</span><span class="nam">edge</span><span class="op">(</span><span class="nam">v1</span><span class="op">,</span> <span class="nam">v2</span><span class="op">,</span> <span class="nam">dir</span><span class="op">=</span><span class="str">"none"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t104" class="pln"><span class="n"><a href="#t104">104</a></span><span class="t">        <span class="com"># print(dot.source)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t105" class="mis show_mis"><span class="n"><a href="#t105">105</a></span><span class="t">        <span class="nam">dot</span><span class="op">.</span><span class="nam">render</span><span class="op">(</span><span class="nam">name</span><span class="op">,</span> <span class="nam">view</span><span class="op">=</span><span class="key">True</span><span class="op">)</span>        <span class="com"># print in pdf</span>&nbsp;</span><span class="r"></span></p>
    <p id="t106" class="pln"><span class="n"><a href="#t106">106</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t107" class="run"><span class="n"><a href="#t107">107</a></span><span class="t">    <span class="key">def</span> <span class="nam">delete_vertex</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">vertex</span><span class="op">)</span><span class="op">:</span>  <span class="com"># delete vertex and all the adjacent edges</span>&nbsp;</span><span class="r"></span></p>
    <p id="t108" class="run"><span class="n"><a href="#t108">108</a></span><span class="t">        <span class="nam">gdict</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span>&nbsp;</span><span class="r"></span></p>
    <p id="t109" class="run"><span class="n"><a href="#t109">109</a></span><span class="t">        <span class="key">for</span> <span class="nam">neighbour</span> <span class="key">in</span> <span class="nam">gdict</span><span class="op">[</span><span class="nam">vertex</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t110" class="run"><span class="n"><a href="#t110">110</a></span><span class="t">            <span class="nam">gdict</span><span class="op">[</span><span class="nam">neighbour</span><span class="op">]</span><span class="op">.</span><span class="nam">remove</span><span class="op">(</span><span class="nam">vertex</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t111" class="run"><span class="n"><a href="#t111">111</a></span><span class="t">        <span class="key">del</span> <span class="nam">gdict</span><span class="op">[</span><span class="nam">vertex</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t112" class="pln"><span class="n"><a href="#t112">112</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t113" class="run"><span class="n"><a href="#t113">113</a></span><span class="t">    <span class="key">def</span> <span class="nam">delete_edge</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">edge</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t114" class="mis show_mis"><span class="n"><a href="#t114">114</a></span><span class="t">        <span class="op">(</span><span class="nam">v1</span><span class="op">,</span> <span class="nam">v2</span><span class="op">)</span> <span class="op">=</span> <span class="nam">edge</span>&nbsp;</span><span class="r"></span></p>
    <p id="t115" class="mis show_mis"><span class="n"><a href="#t115">115</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">[</span><span class="nam">v1</span><span class="op">]</span><span class="op">.</span><span class="nam">remove</span><span class="op">(</span><span class="nam">v2</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t116" class="mis show_mis"><span class="n"><a href="#t116">116</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">[</span><span class="nam">v2</span><span class="op">]</span><span class="op">.</span><span class="nam">remove</span><span class="op">(</span><span class="nam">v1</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t117" class="pln"><span class="n"><a href="#t117">117</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t118" class="run"><span class="n"><a href="#t118">118</a></span><span class="t">    <span class="key">def</span> <span class="nam">dfs_traversal</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">root</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t119" class="mis show_mis"><span class="n"><a href="#t119">119</a></span><span class="t">        <span class="nam">seen</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t120" class="mis show_mis"><span class="n"><a href="#t120">120</a></span><span class="t">        <span class="nam">todo</span> <span class="op">=</span> <span class="op">[</span><span class="nam">root</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t121" class="mis show_mis"><span class="n"><a href="#t121">121</a></span><span class="t">        <span class="nam">gdict</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span>&nbsp;</span><span class="r"></span></p>
    <p id="t122" class="mis show_mis"><span class="n"><a href="#t122">122</a></span><span class="t">        <span class="key">while</span> <span class="nam">len</span><span class="op">(</span><span class="nam">todo</span><span class="op">)</span> <span class="op">></span> <span class="num">0</span><span class="op">:</span>  <span class="com"># while todo ...</span>&nbsp;</span><span class="r"></span></p>
    <p id="t123" class="mis show_mis"><span class="n"><a href="#t123">123</a></span><span class="t">            <span class="nam">current</span> <span class="op">=</span> <span class="nam">todo</span><span class="op">.</span><span class="nam">pop</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t124" class="mis show_mis"><span class="n"><a href="#t124">124</a></span><span class="t">            <span class="nam">seen</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">current</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t125" class="mis show_mis"><span class="n"><a href="#t125">125</a></span><span class="t">            <span class="key">for</span> <span class="nam">neighbour</span> <span class="key">in</span> <span class="nam">gdict</span><span class="op">[</span><span class="nam">current</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t126" class="mis show_mis"><span class="n"><a href="#t126">126</a></span><span class="t">                <span class="key">if</span> <span class="key">not</span><span class="op">(</span><span class="nam">neighbour</span> <span class="key">in</span> <span class="nam">seen</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t127" class="mis show_mis"><span class="n"><a href="#t127">127</a></span><span class="t">                    <span class="nam">todo</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">neighbour</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t128" class="mis show_mis"><span class="n"><a href="#t128">128</a></span><span class="t">        <span class="key">return</span> <span class="nam">seen</span>&nbsp;</span><span class="r"></span></p>
    <p id="t129" class="pln"><span class="n"><a href="#t129">129</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t130" class="run"><span class="n"><a href="#t130">130</a></span><span class="t">    <span class="key">def</span> <span class="nam">is_reachable_from</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">v1</span><span class="op">,</span> <span class="nam">v2</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t131" class="mis show_mis"><span class="n"><a href="#t131">131</a></span><span class="t">        <span class="key">return</span> <span class="nam">v2</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">dfs_traversal</span><span class="op">(</span><span class="nam">v1</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t132" class="pln"><span class="n"><a href="#t132">132</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t133" class="run"><span class="n"><a href="#t133">133</a></span><span class="t">    <span class="key">def</span> <span class="nam">connex_components</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t134" class="mis show_mis"><span class="n"><a href="#t134">134</a></span><span class="t">        <span class="nam">components</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t135" class="mis show_mis"><span class="n"><a href="#t135">135</a></span><span class="t">        <span class="nam">todo</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">vertices</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t136" class="mis show_mis"><span class="n"><a href="#t136">136</a></span><span class="t">        <span class="nam">done</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t137" class="mis show_mis"><span class="n"><a href="#t137">137</a></span><span class="t">        <span class="key">while</span> <span class="nam">todo</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t138" class="mis show_mis"><span class="n"><a href="#t138">138</a></span><span class="t">            <span class="nam">v</span> <span class="op">=</span> <span class="nam">todo</span><span class="op">.</span><span class="nam">pop</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t139" class="mis show_mis"><span class="n"><a href="#t139">139</a></span><span class="t">            <span class="key">if</span> <span class="nam">v</span> <span class="key">not</span> <span class="key">in</span> <span class="nam">done</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t140" class="mis show_mis"><span class="n"><a href="#t140">140</a></span><span class="t">                <span class="nam">v_comp</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">dfs_traversal</span><span class="op">(</span><span class="nam">v</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t141" class="mis show_mis"><span class="n"><a href="#t141">141</a></span><span class="t">                <span class="nam">components</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">v_comp</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t142" class="mis show_mis"><span class="n"><a href="#t142">142</a></span><span class="t">                <span class="nam">done</span><span class="op">.</span><span class="nam">extend</span><span class="op">(</span><span class="nam">v_comp</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t143" class="mis show_mis"><span class="n"><a href="#t143">143</a></span><span class="t">        <span class="key">return</span> <span class="nam">components</span>&nbsp;</span><span class="r"></span></p>
    <p id="t144" class="pln"><span class="n"><a href="#t144">144</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t145" class="run"><span class="n"><a href="#t145">145</a></span><span class="t">    <span class="key">def</span> <span class="nam">bfs_traversal</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">root</span><span class="op">)</span><span class="op">:</span>  <span class="com"># list.pop(0) : for dequeuing (on the left...) !</span>&nbsp;</span><span class="r"></span></p>
    <p id="t146" class="mis show_mis"><span class="n"><a href="#t146">146</a></span><span class="t">        <span class="nam">seen</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t147" class="mis show_mis"><span class="n"><a href="#t147">147</a></span><span class="t">        <span class="nam">todo</span> <span class="op">=</span> <span class="op">[</span><span class="nam">root</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t148" class="mis show_mis"><span class="n"><a href="#t148">148</a></span><span class="t">        <span class="nam">gdict</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span>&nbsp;</span><span class="r"></span></p>
    <p id="t149" class="mis show_mis"><span class="n"><a href="#t149">149</a></span><span class="t">        <span class="key">while</span> <span class="nam">len</span><span class="op">(</span><span class="nam">todo</span><span class="op">)</span> <span class="op">></span> <span class="num">0</span><span class="op">:</span>  <span class="com"># while todo ...</span>&nbsp;</span><span class="r"></span></p>
    <p id="t150" class="mis show_mis"><span class="n"><a href="#t150">150</a></span><span class="t">            <span class="nam">current</span> <span class="op">=</span> <span class="nam">todo</span><span class="op">.</span><span class="nam">pop</span><span class="op">(</span><span class="num">0</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t151" class="mis show_mis"><span class="n"><a href="#t151">151</a></span><span class="t">            <span class="nam">seen</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">current</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t152" class="mis show_mis"><span class="n"><a href="#t152">152</a></span><span class="t">            <span class="key">for</span> <span class="nam">neighbour</span> <span class="key">in</span> <span class="nam">gdict</span><span class="op">[</span><span class="nam">current</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t153" class="mis show_mis"><span class="n"><a href="#t153">153</a></span><span class="t">                <span class="key">if</span> <span class="key">not</span><span class="op">(</span><span class="nam">neighbour</span> <span class="key">in</span> <span class="nam">seen</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t154" class="mis show_mis"><span class="n"><a href="#t154">154</a></span><span class="t">                    <span class="nam">todo</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">neighbour</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t155" class="mis show_mis"><span class="n"><a href="#t155">155</a></span><span class="t">        <span class="key">return</span> <span class="nam">seen</span>&nbsp;</span><span class="r"></span></p>
    <p id="t156" class="pln"><span class="n"><a href="#t156">156</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t157" class="pln"><span class="n"><a href="#t157">157</a></span><span class="t">    <span class="com"># see algo of the course</span>&nbsp;</span><span class="r"></span></p>
    <p id="t158" class="run"><span class="n"><a href="#t158">158</a></span><span class="t">    <span class="key">def</span> <span class="nam">color</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">K</span><span class="op">=</span><span class="key">None</span><span class="op">,</span> <span class="nam">avoidingnodes</span><span class="op">=</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t159" class="pln"><span class="n"><a href="#t159">159</a></span><span class="t">        <span class="str">"""color with &lt;= K color (if K is unspecified, use unlimited colors).</span>&nbsp;</span><span class="r"></span></p>
    <p id="t160" class="pln"><span class="n"><a href="#t160">160</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t161" class="pln"><span class="n"><a href="#t161">161</a></span><span class="t"><span class="str">        Return 3 values:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t162" class="pln"><span class="n"><a href="#t162">162</a></span><span class="t"><span class="str">        - a map vertex-> color</span>&nbsp;</span><span class="r"></span></p>
    <p id="t163" class="pln"><span class="n"><a href="#t163">163</a></span><span class="t"><span class="str">        - a Boolean, True if the coloring succeedeed</span>&nbsp;</span><span class="r"></span></p>
    <p id="t164" class="pln"><span class="n"><a href="#t164">164</a></span><span class="t"><span class="str">        - The set of nodes actually colored</span>&nbsp;</span><span class="r"></span></p>
    <p id="t165" class="pln"><span class="n"><a href="#t165">165</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t166" class="pln"><span class="n"><a href="#t166">166</a></span><span class="t"><span class="str">        Do not color vertices belonging to avoidingnodes.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t167" class="pln"><span class="n"><a href="#t167">167</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t168" class="pln"><span class="n"><a href="#t168">168</a></span><span class="t"><span class="str">        Continue even if the algo fails.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t169" class="pln"><span class="n"><a href="#t169">169</a></span><span class="t"><span class="str">        """</span>&nbsp;</span><span class="r"></span></p>
    <p id="t170" class="run"><span class="n"><a href="#t170">170</a></span><span class="t">        <span class="key">if</span> <span class="nam">K</span> <span class="key">is</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t171" class="run"><span class="n"><a href="#t171">171</a></span><span class="t">            <span class="nam">K</span> <span class="op">=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t172" class="run"><span class="n"><a href="#t172">172</a></span><span class="t">        <span class="nam">todo_vertices</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t173" class="run"><span class="n"><a href="#t173">173</a></span><span class="t">        <span class="nam">is_total</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t174" class="run"><span class="n"><a href="#t174">174</a></span><span class="t">        <span class="nam">gcopy</span> <span class="op">=</span> <span class="nam">deepcopy</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t175" class="pln"><span class="n"><a href="#t175">175</a></span><span class="t">        <span class="com"># suppress nodes that are not to be considered.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t176" class="run"><span class="n"><a href="#t176">176</a></span><span class="t">        <span class="key">for</span> <span class="nam">node</span> <span class="key">in</span> <span class="nam">avoidingnodes</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t177" class="mis show_mis"><span class="n"><a href="#t177">177</a></span><span class="t">            <span class="nam">gcopy</span><span class="op">.</span><span class="nam">delete_vertex</span><span class="op">(</span><span class="nam">node</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t178" class="pln"><span class="n"><a href="#t178">178</a></span><span class="t">        <span class="com"># append nodes in the list according to their degree and node number:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t179" class="run"><span class="n"><a href="#t179">179</a></span><span class="t">        <span class="key">while</span> <span class="nam">gcopy</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t180" class="run"><span class="n"><a href="#t180">180</a></span><span class="t">            <span class="nam">todo</span> <span class="op">=</span> <span class="nam">list</span><span class="op">(</span><span class="nam">gcopy</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t181" class="run"><span class="n"><a href="#t181">181</a></span><span class="t">            <span class="nam">todo</span><span class="op">.</span><span class="nam">sort</span><span class="op">(</span><span class="nam">key</span><span class="op">=</span><span class="key">lambda</span> <span class="nam">v</span><span class="op">:</span> <span class="op">(</span><span class="nam">len</span><span class="op">(</span><span class="nam">gcopy</span><span class="op">.</span><span class="nam">__graph_dict</span><span class="op">[</span><span class="nam">v</span><span class="op">]</span><span class="op">)</span><span class="op">,</span> <span class="nam">v</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t182" class="run"><span class="n"><a href="#t182">182</a></span><span class="t">            <span class="nam">lower</span> <span class="op">=</span> <span class="nam">todo</span><span class="op">[</span><span class="num">0</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t183" class="run"><span class="n"><a href="#t183">183</a></span><span class="t">            <span class="nam">todo_vertices</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">lower</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t184" class="run"><span class="n"><a href="#t184">184</a></span><span class="t">            <span class="nam">gcopy</span><span class="op">.</span><span class="nam">delete_vertex</span><span class="op">(</span><span class="nam">lower</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t185" class="pln"><span class="n"><a href="#t185">185</a></span><span class="t">        <span class="com"># Now reverse the list: first elements are those with higher degree</span>&nbsp;</span><span class="r"></span></p>
    <p id="t186" class="pln"><span class="n"><a href="#t186">186</a></span><span class="t">        <span class="com"># print(todo_vertices)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t187" class="run"><span class="n"><a href="#t187">187</a></span><span class="t">        <span class="nam">todo_vertices</span><span class="op">.</span><span class="nam">reverse</span><span class="op">(</span><span class="op">)</span>  <span class="com"># in place reversal</span>&nbsp;</span><span class="r"></span></p>
    <p id="t188" class="pln"><span class="n"><a href="#t188">188</a></span><span class="t">        <span class="com"># print(todo_vertices)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t189" class="run"><span class="n"><a href="#t189">189</a></span><span class="t">        <span class="nam">coloring</span> <span class="op">=</span> <span class="op">{</span><span class="op">}</span>&nbsp;</span><span class="r"></span></p>
    <p id="t190" class="run"><span class="n"><a href="#t190">190</a></span><span class="t">        <span class="nam">colored_nodes</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t191" class="pln"><span class="n"><a href="#t191">191</a></span><span class="t">        <span class="com"># gdict will be the coloring map to return</span>&nbsp;</span><span class="r"></span></p>
    <p id="t192" class="run"><span class="n"><a href="#t192">192</a></span><span class="t">        <span class="nam">gdict</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">__graph_dict</span>&nbsp;</span><span class="r"></span></p>
    <p id="t193" class="run"><span class="n"><a href="#t193">193</a></span><span class="t">        <span class="key">for</span> <span class="nam">v</span> <span class="key">in</span> <span class="nam">todo_vertices</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t194" class="run"><span class="n"><a href="#t194">194</a></span><span class="t">            <span class="nam">seen_neighbours</span> <span class="op">=</span> <span class="op">[</span><span class="nam">x</span> <span class="key">for</span> <span class="nam">x</span> <span class="key">in</span> <span class="nam">gdict</span><span class="op">[</span><span class="nam">v</span><span class="op">]</span> <span class="key">if</span> <span class="nam">x</span> <span class="key">in</span> <span class="nam">coloring</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t195" class="run"><span class="n"><a href="#t195">195</a></span><span class="t">            <span class="nam">choose_among</span> <span class="op">=</span> <span class="op">[</span><span class="nam">i</span> <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">K</span><span class="op">)</span> <span class="key">if</span> <span class="key">not</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t196" class="pln"><span class="n"><a href="#t196">196</a></span><span class="t">                <span class="nam">i</span> <span class="key">in</span> <span class="op">[</span><span class="nam">coloring</span><span class="op">[</span><span class="nam">v1</span><span class="op">]</span> <span class="key">for</span> <span class="nam">v1</span> <span class="key">in</span> <span class="nam">seen_neighbours</span><span class="op">]</span><span class="op">)</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t197" class="run"><span class="n"><a href="#t197">197</a></span><span class="t">            <span class="key">if</span> <span class="nam">choose_among</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t198" class="pln"><span class="n"><a href="#t198">198</a></span><span class="t">                <span class="com"># if the node can be colored, I choose the minimal color.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t199" class="run"><span class="n"><a href="#t199">199</a></span><span class="t">                <span class="nam">color</span> <span class="op">=</span> <span class="nam">min</span><span class="op">(</span><span class="nam">choose_among</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t200" class="run"><span class="n"><a href="#t200">200</a></span><span class="t">                <span class="nam">coloring</span><span class="op">[</span><span class="nam">v</span><span class="op">]</span> <span class="op">=</span> <span class="nam">color</span>&nbsp;</span><span class="r"></span></p>
    <p id="t201" class="run"><span class="n"><a href="#t201">201</a></span><span class="t">                <span class="nam">colored_nodes</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">v</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t202" class="pln"><span class="n"><a href="#t202">202</a></span><span class="t">            <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t203" class="pln"><span class="n"><a href="#t203">203</a></span><span class="t">                <span class="com"># if I cannot color some node, the coloring is not Total</span>&nbsp;</span><span class="r"></span></p>
    <p id="t204" class="pln"><span class="n"><a href="#t204">204</a></span><span class="t">                <span class="com"># but I continue</span>&nbsp;</span><span class="r"></span></p>
    <p id="t205" class="mis show_mis"><span class="n"><a href="#t205">205</a></span><span class="t">                <span class="nam">is_total</span> <span class="op">=</span> <span class="key">False</span>&nbsp;</span><span class="r"></span></p>
    <p id="t206" class="run"><span class="n"><a href="#t206">206</a></span><span class="t">        <span class="key">return</span> <span class="op">(</span><span class="nam">coloring</span><span class="op">,</span> <span class="nam">is_total</span><span class="op">,</span> <span class="nam">colored_nodes</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
</div>
<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v5.0.3</a>,
            created at 2020-01-26 22:52
        </p>
    </div>
</div>
</body>
</html>
